#include <stdbool.h>
#include <string.h>
#include "math.h"
#include "config.h"
#include "config_param.h"


#define VERSION 13	/*13 ʾV1.3*/

configParam_t configParam;

static configParam_t configParamDefault=
{
	.version = VERSION,		/*汾*/

	.pidAngle=	/*ǶPID*/
	{	
		.roll=
		{
			.kp=5.0,
			.ki=0.0,
			.kd=0.0,
		},
		.pitch=
		{
			.kp=5.0,
			.ki=0.0,
			.kd=0.0,
		},
		.yaw=
		{
			.kp=10.0,
			.ki=0.0,
			.kd=0.35,
		},
	},	
	.pidRate=	/*ٶPID*/
	{	
		.roll=
		{
			.kp=320.0,
			.ki=0.0,
			.kd=5.0,
		},
		.pitch=
		{
			.kp=320.0,
			.ki=0.0,
			.kd=5.0,
		},
		.yaw=
		{
			.kp=120.0,
			.ki=18.5,
			.kd=0.0,
		},
	},	
	.pidPos=	/*λPID*/
	{	
		.vx=
		{
			.kp=0.0,
			.ki=0.0,
			.kd=0.0,
		},
		.vy=
		{
			.kp=0.0,
			.ki=0.0,
			.kd=0.0,
		},
		.vz=
		{
			.kp=21.0,
			.ki=0.0,
			.kd=60.0,
		},
	},
	.thrustBase=36000,	/*Żֵ*/
};

//static u32 lenth = 0;
static bool isInit = false;
//static bool isConfigParamOK = false;
//
//static SemaphoreHandle_t  xSemaphore = NULL;
//
//
//static u8 configParamCksum(configParam_t* data)
//{
//	int i;
//	u8 cksum=0;
//	u8* c = (u8*)data;
//	size_t len=sizeof(configParam_t);
//
//	for (i=0; i<len; i++)
//		cksum += *(c++);
//	cksum-=data->cksum;
//
//	return cksum;
//}
//
//void configParamInit(void)	/*óʼ*/
//{
//	if(isInit) return;
//
//	lenth=sizeof(configParam);
//	lenth=lenth/4+(lenth%4 ? 1:0);
//
////	STMFLASH_Read(CONFIG_PARAM_ADDR, (u32 *)&configParam, lenth);
//
//	if(configParam.version == VERSION)	/*汾ȷ*/
//	{
//		if(configParamCksum(&configParam) == configParam.cksum)	/*Уȷ*/
//		{
//			printf("Version V%1.1f check [OK]\r\n", configParam.version / 10.0f);
//			isConfigParamOK = true;
//		} else
//		{
//			printf("Version check [FAIL]\r\n");
//			isConfigParamOK = false;
//		}
//	}
//	else	/*汾*/
//	{
//		isConfigParamOK = false;
//	}
//
//	if(isConfigParamOK == false)	/*òдĬϲ*/
//	{
//		memcpy((u8 *)&configParam, (u8 *)&configParamDefault, sizeof(configParam));
//		configParam.cksum = configParamCksum(&configParam);				/*Уֵ*/
//		STMFLASH_Write(CONFIG_PARAM_ADDR,(u32 *)&configParam, lenth);	/*дstm32 flash*/
//		isConfigParamOK=true;
//	}
//
//	xSemaphore = xSemaphoreCreateBinary();
//
//	isInit=true;
//}
//
//void configParamTask(void* param)
//{
//	u8 cksum = 0;
//
//	while(1)
//	{
//		xSemaphoreTake(xSemaphore, portMAX_DELAY);
//		cksum = configParamCksum(&configParam);		/*У*/
//
//		if(configParam.cksum != cksum)
//		{
//			configParam.cksum = cksum;	/*У*/
//			watchdogInit(1000);			/*ʱȽϳŹʱôһЩ*/
//			STMFLASH_Write(CONFIG_PARAM_ADDR,(u32 *)&configParam, lenth);	/*дstm32 flash*/
//			watchdogInit(WATCHDOG_RESET_MS);		/*ÿŹ*/
//		}
//	}
//}

bool configParamTest(void)
{
	return isInit;
}

void configParamGiveSemaphore(void)
{
//	xSemaphoreGive(xSemaphore);
}

void resetConfigParamPID(void)
{
	configParam.pidAngle = configParamDefault.pidAngle;
	configParam.pidRate = configParamDefault.pidRate;
	configParam.pidPos = configParamDefault.pidPos;
}
