#ifndef __CONFIG_PARAM_H
#define __CONFIG_PARAM_H
#include <math.h>
#include <stdbool.h>
#include "config.h"
#define DEG2RAD     0.017453293f    /* ת /180 */
#define RAD2DEG     57.29578f       /* ת 180/ */

												
typedef struct 
{
	float kp;
	float ki;
	float kd;
} pidInit_t;

typedef struct
{
	pidInit_t roll;
	pidInit_t pitch;	
	pidInit_t yaw;	
} pidParam_t;

typedef struct
{
	pidInit_t vx;
	pidInit_t vy;
	pidInit_t vz;	
} pidParamPos_t;

typedef struct	
{
	u8 version;				/*汾*/
	pidParam_t pidAngle;	/*ǶPID*/	
	pidParam_t pidRate;		/*ٶPID*/	
	pidParamPos_t pidPos;	/*λPID*/
	u16 thrustBase;			/*Żֵ*/
	u8 cksum;				/*У*/
} configParam_t;


extern configParam_t configParam;

void configParamInit(void);	/*óʼ*/
void configParamTask(void* param);	/**/
bool configParamTest(void);

void configParamGiveSemaphore(void);
void resetConfigParamPID(void);

#endif /*__CONFIG_PARAM_H */

