#include "power_control.h"
#include "motor.h"
#include "stdint.h"
#include "config.h"

#define MOTORS_PWM_BITS             8
#define MOTORS_PWM_PERIOD           ((1<<MOTORS_PWM_BITS) - 1)
#define MOTORS_PWM_PRESCALE         0

static bool motorSetEnable = false;
static motorPWM_t motorPWM;
static motorPWM_t motorPWMSet={0, 0, 0, 0};

static u16 ratioToCCRx(u16 val)
{
    return ((val) >> (16 - MOTORS_PWM_BITS) & ((1 << MOTORS_PWM_BITS) - 1));
}


void powerControlInit(void)
{
	init_motor();
}

bool powerControlTest(void)
{
	bool pass = true;

	//pass &= motorsTest();

	return pass;
}

u16 limitThrust(int value)
{
	if(value > UINT16_MAX)
	{
		value = UINT16_MAX;
	}
	else if(value < 0)
	{
		value = 0;
	}

	return (u16)value;
}

void powerControl(control_t *control)	/**/
{
	s16 r = control->roll / 2.0f;
	s16 p = control->pitch / 2.0f;
	
	motorPWM.m1 = limitThrust(control->thrust - r - p + control->yaw);
	motorPWM.m2 = limitThrust(control->thrust - r + p - control->yaw);
	motorPWM.m3 = limitThrust(control->thrust + r + p + control->yaw);
	motorPWM.m4 = limitThrust(control->thrust + r - p - control->yaw);		

	if (motorSetEnable)
	{
		motorPWM=motorPWMSet;
	}
	PRINT("M1=%d   M2=%d   M3=%d   M4=%d   \r\n", motorPWM.m1,motorPWM.m2,motorPWM.m3,motorPWM.m4);
	//UL_motor_speed_set(ratioToCCRx(motorPWM.m1));//Ͻǵٶ
	//UR_motor_speed_set(ratioToCCRx(motorPWM.m2));//Ͻǵٶ
	//DL_motor_speed_set(ratioToCCRx(motorPWM.m3));//½ǵٶ
	//DR_motor_speed_set(ratioToCCRx(motorPWM.m4));//½ǵٶ
}

void getMotorPWM(motorPWM_t* get)
{
	*get = motorPWM;
}
