#include <math.h>
#include "sensfusion6.h"
#include "config.h"
#include "config_param.h"


float Kp = 0.4f;		/**/
float Ki = 0.001f;		/**/
float exInt = 0.0f;
float eyInt = 0.0f;
float ezInt = 0.0f;		/*ۼ*/

static float q0 = 1.0f;	/*Ԫ*/
static float q1 = 0.0f;
static float q2 = 0.0f;
static float q3 = 0.0f;

static float baseZacc = 1.0;		/*̬Zٶ*/
static bool isCalibrated = false;


static float invSqrt(float x);	/*ٿƽ*/

void imuUpdate(Axis3f acc, Axis3f gyro, state_t *state , float dt)	/*ں ˲*/
{
    double temp1,temp2;
	float normalise;
	float ex, ey, ez;
	float q0s, q1s, q2s, q3s;	/*Ԫƽ*/
	static float R11,R21;		/*(1,1),(2,1)*/
	static float vecxZ, vecyZ, veczZ;	/*ϵµZ*/
	float halfT =0.5f * dt;
	Axis3f tempacc =acc;

	gyro.x = gyro.x * DEG2RAD;	/* ת */
	gyro.y = gyro.y * DEG2RAD;
	gyro.z = gyro.z * DEG2RAD;

	/* ĳһٶȲΪ0 */
	if((acc.x != 0.0f) || (acc.y != 0.0f) || (acc.z != 0.0f))
	{
		/*λټƲֵ*/
		normalise = invSqrt(acc.x * acc.x + acc.y * acc.y + acc.z * acc.z);
		acc.x *= normalise;
		acc.y *= normalise;
		acc.z *= normalise;

		/*ټƶȡķټƷĲֵ˼*/
		ex = (acc.y * veczZ - acc.z * vecyZ);
		ey = (acc.z * vecxZ - acc.x * veczZ);
		ez = (acc.x * vecyZ - acc.y * vecxZ);
		
		/*ۼƣֳ*/
		exInt += Ki * ex * dt ;
		eyInt += Ki * ey * dt ;
		ezInt += Ki * ez * dt ;
		
		/*òPIƫݶеƫ*/
		gyro.x += Kp * ex + exInt;
		gyro.y += Kp * ey + eyInt;
		gyro.z += Kp * ez + ezInt;
	}
	/* һ׽㷨Ԫ˶ѧ̵ɢʽͻ */
	q0 += (-q1 * gyro.x - q2 * gyro.y - q3 * gyro.z) * halfT;
	q1 += (q0 * gyro.x + q2 * gyro.z - q3 * gyro.y) * halfT;
	q2 += (q0 * gyro.y - q1 * gyro.z + q3 * gyro.x) * halfT;
	q3 += (q0 * gyro.z + q1 * gyro.y - q2 * gyro.x) * halfT;
	
	/*λԪ*/
	normalise = invSqrt((q0 * q0) + (q1 * q1) + (q2 * q2) + (q3 * q3));
	q0 *= normalise;
	q1 *= normalise;
	q2 *= normalise;
	q3 *= normalise;
	/*Ԫƽ*/
	q0s = q0 * q0;
	q1s = q1 * q1;
	q2s = q2 * q2;
	q3s = q3 * q3;
	
	R11 = q0s + q1s - q2s - q3s;	/*(1,1)*/
	R21 = 2 * (q1 * q2 + q0 * q3);	/*(2,1)*/

	/*ϵµZ*/
	vecxZ = 2 * (q1 * q3 - q0 * q2);/*(3,1)*/
	vecyZ = 2 * (q0 * q1 + q2 * q3);/*(3,2)*/
	veczZ = q0s - q1s - q2s + q3s;	/*(3,3)*/
	
	if (vecxZ>1) vecxZ=1;
	if (vecxZ<-1) vecxZ=-1;
	
	/*roll pitch yaw ŷ*/
	state->attitude.pitch = -asinf(vecxZ) * RAD2DEG; 
	state->attitude.roll = atan2f(vecyZ, veczZ) * RAD2DEG;
	state->attitude.yaw = atan2f(R21, R11) * RAD2DEG;
	
	if (!isCalibrated)	/*У׼*/
	{
		baseZacc = tempacc.x* vecxZ + tempacc.y * vecyZ + tempacc.z * veczZ;
		isCalibrated = true;
	}
	state->acc.z= tempacc.x* vecxZ + tempacc.y * vecyZ + tempacc.z * veczZ - baseZacc;	/*Zٶ(ȥٶ)*/
}

// Fast inverse square-root
// See: http://en.wikipedia.org/wiki/Fast_inverse_square_root
float invSqrt(float x)	/*ٿƽ*/
{
	float halfx = 0.5f * x;
	float y = x;
	long i = *(long*)&y;
	i = 0x5f3759df - (i>>1);
	y = *(float*)&i;
	y = y * (1.5f - (halfx * y * y));
	return y;
}



