/* ͷļ */
#include "HAL.h"
#include "stabilizer.h"
#include "sensors.h"
#include "commander.h"
#include "anomal_detec.h"
#include "state_control.h"
#include "state_estimator.h"
#include "power_control.h"
#include "flip.h"


static bool isInit = 0;
static bool isCalibPass;
static setpoint_t 	setpoint;	/*Ŀ״̬*/
static sensorData_t sensorData;	/**/
static state_t 		state;		/*̬*/
static control_t 	control;	/*Ʋ*/

tmosTaskID stabilizerTaskID = INVALID_TASK_ID;




void stabilizerInit(void)
{
    u8 temp = 0;

    stabilizerTaskID = TMOS_ProcessEventRegister(stabilizerEventProcess);
    PRINT("עɹ TaskIDΪ = %d\r\n",stabilizerTaskID);
	if(isInit) return;

	sensorsInit();			/*ʼ*/

	stateControlInit();		/*̬PIDʼ*/

	powerControlInit();		/*ʼ*/

	isInit = true;
    //while(!sensorsAreCalibrated())
    {
        //vTaskDelayUntil(&lastWakeTime, MAIN_LOOP_DT);
    }
    isCalibPass = true;
    //PRINT("ʼstabilizerEventProcess\r\n");
    tmos_start_task(stabilizerTaskID, STABALIZER_PULSE_EVENT,MS1_TO_SYSTEM_TIME(20));

}

bool stabilizerTest(void)
{
	bool pass = true;

	pass &= sensorsTest();
	pass &= stateControlTest();
	pass &= powerControlTest();

	return pass;
}


static u8 flag = 0;
tmosEvents stabilizerEventProcess(tmosTaskID task_id, tmosEvents events)
{

    uint8_t *msgPtr;
    if(flag==0)
    {
        flag = 1;
        PRINT("stabilizerEventProcess\r\n");
    }

    if(events & SYS_EVENT_MSG)
    { // HALϢtmos_msg_receiveȡϢɺɾϢ
       msgPtr = tmos_msg_receive(task_id);
       if(msgPtr)
       {
           /* De-allocate */
           tmos_msg_deallocate(msgPtr);
       }
       return events ^ SYS_EVENT_MSG;
    }
	if(events & STABALIZER_PULSE_EVENT)
	{
		sensorsAcquire(&sensorData);					/*ȡ6*/
		stateEstimator(&state, &sensorData);			/*Ԫ ŷǼ*/
		commanderGetSetpoint(&setpoint, &state);			/*Ŀݺͷģʽ趨*/
		flyerFlipCheck(&setpoint, &control, &state);	/**/
		anomalDetec(&sensorData, &state, &control);			/*쳣*/
		stateControl(&control, &sensorData, &state, &setpoint);/*PID*/
		powerControl(&control);								/*Ƶ*/
		tmos_start_task(stabilizerTaskID, STABALIZER_PULSE_EVENT, MS1_TO_SYSTEM_TIME(100));
		return events ^ STABALIZER_PULSE_EVENT;
	}
	return 0;
}

void getAttitudeData(attitude_t* get)
{
	*get = state.attitude;
}

float getBaroData(void)
{
	return sensorData.baro.asl;
}

bool getIsCalibPass(void)
{
	return isCalibPass;
}
