#include "string.h"
#include "stabilizer.h"
#include "sensfusion6.h"
#include "state_control.h"
#include "attitude_pid.h"
#include "position_pid.h"
//#include "config_param.h"


static float actualThrust;
static attitude_t attitudeDesired;
static attitude_t rateDesired;


void stateControlInit(void)
{
	attitudeControlInit();	/*ʼ̬PID*/	
	positionControlInit();	/*ʼλPID*/
}

bool stateControlTest(void)
{
	bool pass = true;
	pass &= attitudeControlTest();
	return pass;
} 

void stateControl(control_t *control, sensorData_t *sensors, state_t *state, setpoint_t *setpoint)
{
	static u16 cnt = 0;
	

	altholdPID(&actualThrust, state, setpoint);		/* PID(ٶģʽ)*/

    if(setpoint->isAltHold == false)
    {
        actualThrust = setpoint->thrust;
    }
    if(control->flipDir == CENTER)
    {
        attitudeDesired.yaw -= setpoint->attitude.yaw/ATTITUDE_UPDATE_RATE;	/*YAW ģʽ*/
        while(attitudeDesired.yaw > 180.0f)
            attitudeDesired.yaw -= 360.0f;
        while(attitudeDesired.yaw < -180.0f)
            attitudeDesired.yaw += 360.0f;
    }
    attitudeDesired.roll = setpoint->attitude.roll;		/*ROLL Ƕ()ģʽ*/
    attitudeDesired.pitch = setpoint->attitude.pitch;	/*PITCH Ƕ()ģʽ*/

    attitudeAnglePID(&state->attitude, &attitudeDesired, &rateDesired);	/* Ƕ(⻷)PID */

    if(control->flipDir != CENTER)	/*շʱֻʹڻPID*/
    {
        rateDesired.pitch = setpoint->attitude.pitch;
        rateDesired.roll = setpoint->attitude.roll;
    }
    attitudeRatePID(&sensors->gyro, &rateDesired, control);				/* ٶ(ڻ)PID */

	#ifdef ENABLE_PID_TUNING	/* ʹPID yawֵ */
		control->yaw = 0;	
	#endif


	control->thrust = (u16)actualThrust;	

	if (control->thrust == 0)
	{			
		control->thrust = 0;
		control->roll = 0;
		control->pitch = 0;
		control->yaw = 0;
		
		attitudeResetAllPID();	/*λ̬PID*/	
		positionResetAllPID();	/*λλPID*/
		attitudeDesired.yaw = state->attitude.yaw;	/*λyawֵ*/
		
		float velZ = state->velocity.z;
		if(velZ<0.001f && velZ>-0.001f && cnt++>1000)	/*ɺ󱣴*/
		{
			cnt = 0;
			//configParamGiveSemaphore();
		}
	}

}


