#ifndef __STATE_ESTIMATOR_H
#define __STATE_ESTIMATOR_H
#include "stabilizer_types.h"

typedef struct
{
	float estimatedZ; // The current Z estimate, has same offset as asl
	float velocityZ; // Vertical speed (world frame) integrated from vertical acceleration (m/s)
	float estAlpha;
	float velocityFactor;
	float vAccDeadband; // Vertical acceleration deadband
	float velZAlpha;   // Blending factor to avoid vertical speed to accumulate error
	float velocityX;	/* x ٶ(ϵ) xٶȻֵó λ(m/s)*/
	float velocityY;	/* y ٶ(ϵ) yٶȻֵó λ(m/s)*/
} selfState_t;

void stateEstimator(state_t *state, const sensorData_t *sensorData);

#endif /* __STATE_ESTIMATOR_H */
