/*
 * Fly_ctrl_handle.h
 *
 *  Created on: 2022212
 *      Author: xiedc
 */

#ifndef _FLY_CTRL_HANDLE_H_
#define _FLY_CTRL_HANDLE_H_
#include "HAL.h"
#include "CONFIG.h"


#define POWER_KEY_EVENT                   0x0001  //Դ¼
#define BAT_VALUE_SCAN_EVENT              0x0002  //صѹɨ¼
#define MOVE_FOWARD_EVENT                 0x0004  //ǰƶ¼
#define MOVE_BACKWARD_EVENT               0x0008  //ƶ¼
#define MOVE_LEFT_EVENT                   0x0010  //ƶ¼
#define MOVE_RIGHT_EVENT                  0x0020  //ƶ¼
#define TURN_LEFT_EVENT                   0x0040  //ת
#define TURN_RIGHT_EVENT                  0x0080  //ת
#define FLY_SELF_CTRL_EVENT               0x0100  //״̬ҿ


#define STATE_UPDATE_TIME                 16  //10MS = 16*625us

//
typedef struct{
s16 ACCEL_X;
s16 ACCEL_Y;
s16 ACCEL_Z;
s16 GYRO_X;
s16 GYRO_Y;
s16 GYRO_Z;
}SENSOR_DATA;


//PWM
typedef struct{
u8  PWM_UL;
u8  PWM_UR;
u8  PWM_DL;
u8  PWM_DR;
}PWM_DATA;

//״̬
typedef enum {
  NOT_CTRL = 0,
  FOWARD  ,
  BACKWARD,
  //LEFT ,
  //RIGHT ,
  TURN_LEFT,
  TURN_RIGHT,
}CTRL_STATE;


extern SENSOR_DATA sensor_data;
extern PWM_DATA pwm;
extern CTRL_STATE ctrl_state;
uint16 Fly_ctrl_ProcessEvent(uint8 task_id, uint16 events);
static void Fly_ctrl_ProcessTMOSMsg(tmos_event_hdr_t *pMsg);
#endif /* _FLY_CTRL_HANDLE_H_ */
