/*
 * fly_ctrl_handle.c
 *
 *  Created on: 2022212
 *      Author: xiedc
 */

#include "Fly_ctrl_handle.h"
#include "MPU6050.h"
//#include "CH58xBLE_LIB.H"

//пID
uint8 Fly_ctrl_TaskID = INVALID_TASK_ID;// Task ID for internal task/event processing

SENSOR_DATA sensor_data;
PWM_DATA pwm;
CTRL_STATE ctrl_state;



void sensor_read(SENSOR_DATA *sensor)
{
    sensor->ACCEL_X = GetData(ACCEL_XOUT_H);
    sensor->ACCEL_Y = GetData(ACCEL_YOUT_H);
    sensor->ACCEL_Z = GetData(ACCEL_ZOUT_H);
    sensor->GYRO_X = GetData(GYRO_XOUT_H);
    sensor->GYRO_Y = GetData(GYRO_YOUT_H);
    sensor->GYRO_Z = GetData(GYRO_ZOUT_H);
}
void Fly_ctrl_init(void)
{
    Fly_ctrl_TaskID = TMOS_ProcessEventRegister(Fly_ctrl_ProcessEvent);
    ctrl_state = NOT_CTRL;//״̬ʼ
    tmos_start_task(Fly_ctrl_TaskID, FLY_SELF_CTRL_EVENT, 160);//100msʼп
}
//ɿ¼
uint16 Fly_ctrl_ProcessEvent(uint8 task_id, uint16 events)
{

    if(events & SYS_EVENT_MSG)
    {
       uint8 *pMsg;

       if((pMsg = tmos_msg_receive(Fly_ctrl_TaskID)) != NULL)
       {
           Fly_ctrl_ProcessTMOSMsg((tmos_event_hdr_t *)pMsg);
           // Release the TMOS message
           tmos_msg_deallocate(pMsg);
       }
       // return unprocessed events
       return (events ^ SYS_EVENT_MSG);
    }
    //Դ
    if(events & POWER_KEY_EVENT)
    {
        //ػ¼BLE,BLEú״̬󷢹ػ¼HALHALִйػ
        return (events ^ POWER_KEY_EVENT);
    }
    if(events & BAT_VALUE_SCAN_EVENT)
    {
        //adcأȻӦĴ
        //
        tmos_start_task(Fly_ctrl_TaskID, BAT_VALUE_SCAN_EVENT, 1000);
        return (events ^ BAT_VALUE_SCAN_EVENT);
    }
    if(events & FLY_SELF_CTRL_EVENT)
    {
        //ȡMPU6050
        sensor_read(&sensor_data);
        //PID
        //״ִ̬
        //ת8bit
        //PWMռձ
        tmos_start_task(Fly_ctrl_TaskID, FLY_SELF_CTRL_EVENT, STATE_UPDATE_TIME);//ø¿
        return (events ^ FLY_SELF_CTRL_EVENT);
    }
    //ǰƶ
    if(events & MOVE_FOWARD_EVENT)
    {
        if (ctrl_state==NOT_CTRL)
        {
            ctrl_state = FOWARD;
            tmos_start_task(Fly_ctrl_TaskID, MOVE_FOWARD_EVENT, 1600);
        }
        else
        {
            ctrl_state = NOT_CTRL;
        }

        return (events ^ MOVE_FOWARD_EVENT);
    }
    //ƶ
    if(events & MOVE_BACKWARD_EVENT)
    {
        if (ctrl_state==NOT_CTRL)
        {
           ctrl_state = BACKWARD;
           tmos_start_task(Fly_ctrl_TaskID, MOVE_BACKWARD_EVENT, 1600);
        }
        else
        {
           ctrl_state = NOT_CTRL;
        }
        return (events ^ MOVE_BACKWARD_EVENT);
    }
    //ƶ
    if(events & MOVE_LEFT_EVENT)
    {
        if (ctrl_state==NOT_CTRL)
        {
           //ctrl_state = LEFT;
           tmos_start_task(Fly_ctrl_TaskID, MOVE_LEFT_EVENT, 1600);
        }
        else
        {
           ctrl_state = NOT_CTRL;
        }
        return (events ^ MOVE_LEFT_EVENT);
    }
    //ƶ
    if(events & MOVE_RIGHT_EVENT)
    {
        if (ctrl_state==NOT_CTRL)
        {
         //  ctrl_state = RIGHT;
           tmos_start_task(Fly_ctrl_TaskID, MOVE_RIGHT_EVENT, 1600);
        }
        else
        {
           ctrl_state = NOT_CTRL;
        }
        return (events ^ MOVE_RIGHT_EVENT);
    }
    //ת
    if(events & TURN_LEFT_EVENT)
    {
        if (ctrl_state==NOT_CTRL)
        {
           ctrl_state = TURN_LEFT;
           tmos_start_task(Fly_ctrl_TaskID, TURN_LEFT_EVENT, 1600);
        }
        else
        {
           ctrl_state = NOT_CTRL;
        }
        return (events ^ TURN_LEFT_EVENT);
    }
    //ת
    if(events & TURN_RIGHT_EVENT)
    {
        if (ctrl_state==NOT_CTRL)
        {
           ctrl_state = TURN_RIGHT;
           tmos_start_task(Fly_ctrl_TaskID, TURN_RIGHT_EVENT, 1600);
        }
        else
        {
           ctrl_state = NOT_CTRL;
        }
        return (events ^ TURN_RIGHT_EVENT);
    }
    return 0;
}

/*********************************************************************
 * @fn      Fly_ctrl_ProcessTMOSMsg
 *
 * @brief   Process an incoming task message.
 *
 * @param   pMsg - message to process
 *
 * @return  none
 */
static void Fly_ctrl_ProcessTMOSMsg(tmos_event_hdr_t *pMsg)
{
    switch(pMsg->event)
    {
        case POWER_KEY_EVENT:
        break;

        default:
            break;
    }
}

